﻿Imports Infragistics.Win.UltraWinDataSource

Public Class Form1

    Private Counter As Integer

    Public Sub New()

        InitializeComponent()

        'If System.IO.File.Exists(Application.StartupPath + "\grid.xml") = False Then
        '    Me.CreateXMLFile()
        'End If

        'Dim ds As New DataSet("Main")

        'ds.ReadXml(Application.StartupPath + "\grid.xml")

        UltraGrid1.DisplayLayout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True
        UltraGrid1.DisplayLayout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow

        'UltraGrid1.DataSource = ds
        'UltraGrid1.DataBind()
        Me.CreateUltraDataSource()
        UltraGrid1.DataSource = Me.UltraDataSource1
    End Sub

    Public Sub ExcelExport(ByVal sender As Object, ByVal e As EventArgs) Handles Button1.Click

        Dim sw As Stopwatch = Stopwatch.StartNew()

        UltraGridExcelExporter1.OutliningStyle = Infragistics.Win.UltraWinGrid.ExcelExport.OutliningStyle.RaiseExceptionOnDepthOverflow
        UltraGridExcelExporter1.Export(UltraGrid1, Application.StartupPath + "\export.xls")
        'UltraGridExcelExporter1.Export(UltraGrid1, Application.StartupPath + "\export.xlsx")

        sw.Stop()
        MessageBox.Show(sw.Elapsed.TotalSeconds)

    End Sub

    Private Sub ExcelExport_InitializeRow(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.ExcelExport.ExcelExportInitializeRowEventArgs) Handles UltraGridExcelExporter1.InitializeRow
        'If e.Row.IsFilteredOut Then
        '    e.SkipRow = True
        '    e.SkipDescendants = True
        '    e.Row.Band.ColHeadersVisible = False
        '    e.Row.Band.HeaderVisible = False
        'End If

        Me.Counter += 1
    End Sub

    Private Sub CreateXMLFile()
        Dim Writer As New Xml.XmlTextWriter(Application.StartupPath + "\grid.xml", System.Text.Encoding.UTF8)

        Writer.WriteStartDocument()
        Writer.Formatting = Xml.Formatting.Indented
        Writer.Indentation = 2
        Writer.WriteStartElement("NewDataSet")

        For i As Integer = 1 To 10000
            Writer.WriteStartElement("Node1")
            Writer.WriteStartElement("Node1_ID")
            Writer.WriteString(i.ToString)
            Writer.WriteEndElement()
            Writer.WriteStartElement("Node1_Name")
            Writer.WriteString("Node 1 - Element " + i.ToString)
            Writer.WriteEndElement()

            For j As Integer = 1 To 20
                Writer.WriteStartElement("Node2")
                Writer.WriteStartElement("Node2_ID")
                Writer.WriteString(j.ToString)
                Writer.WriteEndElement()
                Writer.WriteStartElement("Node2_Name")
                Writer.WriteString("Node 2 - Element " + j.ToString)
                Writer.WriteEndElement()
                Writer.WriteEndElement()
            Next


            Writer.WriteEndElement()
        Next i

        Writer.WriteEndElement()
        Writer.WriteEndDocument()
        Writer.Close()
    End Sub

    Private Sub CreateUltraDataSource()
        Me.UltraDataSource1.Reset()

        With Me.UltraDataSource1
            With .Band
                .Columns.Add("Node1_Id", GetType(Integer))
                .Columns.Add("Node1_Name", GetType(String))
            End With

            With .Band.ChildBands.Add("Band 1")
                .Columns.Add("Node2_Id", GetType(Integer))
                .Columns.Add("Node2_Name", GetType(String))
            End With

            With .Rows
                For i As Integer = 1 To 10000
                    Dim parentRow As UltraDataRow = .Add(New Object() {i, "Node 1 - Element " + i.ToString})

                    With parentRow.GetChildRows(0)
                        For j As Integer = 1 To 20
                            .Add(New Object() {j, "Node 2 - Element " + j.ToString})
                        Next

                    End With
                Next i
            End With

        End With

    End Sub

End Class
